import { ElementRef, EventEmitter, OnInit } from '@angular/core';
import * as d3 from 'd3';
import { RenderOptions, Vescell } from 'ng-container-terminal/core';
import { CtVescellParserService } from 'ng-container-terminal/tool';
import { Subject } from 'rxjs';
import * as i0 from "@angular/core";
export declare class CtVesselBayComponent<T> implements OnInit {
    private el;
    private cellParser;
    set renderOptions(options: RenderOptions<Vescell<T>>);
    get renderOptions(): RenderOptions<Vescell<T>>;
    set cellSize(size: number);
    get cellSize(): number;
    set vescells(vescells: Vescell<T>[]);
    get vescells(): Vescell<T>[];
    set name(name: string);
    get name(): string;
    displayName: string;
    vescellClick: EventEmitter<Vescell<T>>;
    contentRender: EventEmitter<{
        node: d3.Selection<any, any, any, any>;
        data: Vescell<T>;
    }>;
    constructor(el: ElementRef, cellParser: CtVescellParserService);
    renderUpdateSubject: Subject<void>;
    host: d3.Selection<any, any, any, any>;
    svg: d3.Selection<any, any, any, any>;
    vesselDeckBayGroup: d3.Selection<any, any, any, any>;
    vesselDeckBayRowLabelGroup: d3.Selection<any, any, any, any>;
    vesselDeckBayTierLabelGroup: d3.Selection<any, any, any, any>;
    vesselDeckBayCellGroup: d3.Selection<any, any, any, any>;
    vesselHoldBayGroup: d3.Selection<any, any, any, any>;
    vesselHoldBayRowLabelGroup: d3.Selection<any, any, any, any>;
    vesselHoldBayTierLabelGroup: d3.Selection<any, any, any, any>;
    vesselHoldBayCellGroup: d3.Selection<any, any, any, any>;
    vesselBayNameLabelGroup: d3.Selection<any, any, any, any>;
    private _vescells;
    padding: number;
    private deckRowLabels;
    private deckTierLabels;
    private deckCells;
    private holdRowLabels;
    private holdTierLabels;
    private holdCells;
    private layout;
    private _name;
    private _cellSize;
    private _renderOptions;
    cellTrackByFn: (cell: Vescell<T>) => string;
    ngOnInit(): void;
    /**
     * 船箱位数据发生变化时，重新对输入数据进行预处理
     *
     */
    premarshalling(cells: Vescell<T>[]): void;
    /**
     * ## 绘制贝位结构
     *
     * 1. 规划舱内舱面绘制区域
     * 2. 规划舱内舱面行、列标签绘制区域
     * 3. 规划舱内舱面船箱位绘制区域
     *
     */
    renderAll(): void;
    renderTierLabels(selection: d3.Selection<SVGGElement, string, SVGGElement, any>, data: string[]): void;
    renderRowLabels(selection: d3.Selection<SVGGElement, string, SVGGElement, any>, data: string[], rowOffset: number): void;
    renderVescells(): void;
    private _fillFunction;
    private hasZeroRow;
    private _renderText;
    static ɵfac: i0.ɵɵFactoryDeclaration<CtVesselBayComponent<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<CtVesselBayComponent<any>, "ct-vessel-bay", never, { "renderOptions": "renderOptions"; "cellSize": "cellSize"; "vescells": "vescells"; "name": "name"; "cellTrackByFn": "cellTrackByFn"; }, { "vescellClick": "vescellClick"; "contentRender": "contentRender"; }, never, never>;
}
