import { ElementRef, EventEmitter, OnChanges, OnInit, SimpleChanges } from '@angular/core';
import * as d3 from 'd3';
import { RenderOptions, YardBay, Yardpos } from 'ng-container-terminal/core';
import { CtYardposParserService } from 'ng-container-terminal/tool';
import * as i0 from "@angular/core";
export declare class CtYardBayComponent<T> implements OnInit, OnChanges {
    private el;
    private yardposParser;
    host: d3.Selection<any, any, any, any>;
    svg: d3.Selection<any, any, any, any>;
    yardBayGroup: d3.Selection<any, any, any, any>;
    yardBayRowLabelGroup: d3.Selection<any, any, any, any>;
    yardBayTierLabelGroup: d3.Selection<any, any, any, any>;
    yardBayNameLabelGroup: d3.Selection<any, any, any, any>;
    yardposInfoGroup: d3.Selection<any, any, any, any>;
    poses: Yardpos<T>[];
    padding: number;
    private _yardBay;
    private _renderOptions;
    private _size;
    displaySize: {
        row: number;
        tier: number;
    };
    set size(s: {
        row: number;
        tier: number;
    });
    get size(): {
        row: number;
        tier: number;
    };
    set renderOptions(options: RenderOptions<Yardpos<T>>);
    get renderOptions(): RenderOptions<Yardpos<T>>;
    cellSize: number;
    set yardBay(yardBay: YardBay<T>);
    get yardBay(): YardBay<T>;
    yardposClick: EventEmitter<Yardpos<T>>;
    constructor(el: ElementRef, yardposParser: CtYardposParserService);
    ngOnInit(): void;
    generatePoses(): void;
    resize(): void;
    ngOnChanges(changes: SimpleChanges): void;
    /**
     * 绘制贝位结构
     */
    renderLayout(): void;
    updateYardposInfo(): void;
    renderYardposInfo(selection: d3.Selection<any, any, any, any>): void;
    private _fillFunction;
    private draw;
    private _renderPosText;
    static ɵfac: i0.ɵɵFactoryDeclaration<CtYardBayComponent<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<CtYardBayComponent<any>, "ct-yard-bay", never, { "size": "size"; "renderOptions": "renderOptions"; "cellSize": "cellSize"; "yardBay": "yardBay"; }, { "yardposClick": "yardposClick"; }, never, never>;
}
