import { ElementRef, EventEmitter, OnChanges, OnInit, SimpleChanges } from '@angular/core';
import * as d3 from 'd3';
import { RenderOptions, YardposInfo } from 'ng-container-terminal/core';
import { CtYardposParserService } from 'ng-container-terminal/tool';
import { BehaviorSubject } from 'rxjs';
import * as i0 from "@angular/core";
export declare class CtYardComponent implements OnInit, OnChanges {
    private el;
    private yardposParser;
    host: d3.Selection<any, any, any, any>;
    svg: d3.Selection<any, any, any, any>;
    yardGroup: d3.Selection<any, any, any, any>;
    rowLabelsGroup: d3.Selection<any, any, any, any>;
    oddBayLabelsGroup: d3.Selection<any, any, any, any>;
    evenBayLabelsGroup: d3.Selection<any, any, any, any>;
    displayYardposInfoList: YardposInfo[];
    interval: number;
    maxRow: number;
    maxTier: number;
    maxBay: number;
    canvasWidth: number;
    canvasHeight: number;
    pods: any[];
    podColor: any;
    block: string;
    private _renderOptions;
    set renderOptions(options: RenderOptions<YardposInfo>);
    get renderOptions(): RenderOptions<YardposInfo>;
    yardposInfoList: YardposInfo[];
    baseWidth: number;
    baseHeight: number;
    rotation: number;
    yardposClick: EventEmitter<YardposInfo>;
    onNotifyDataChanged: BehaviorSubject<boolean>;
    onNotifyDataChanged$: import("rxjs").Observable<boolean>;
    constructor(el: ElementRef, yardposParser: CtYardposParserService);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    /**
     * 当yardposInfoList里面的相关属性发生变化时，通知视图进行刷行
     */
    notifyDataUpdated(redrawOnly?: boolean): void;
    /**
     * 从场地位置信息数组中剔除箱区基础数据，即:
     * maxBay: 小贝个数
     * maxRow: 最大列
     * maxTier: 最大层
     * pods: 所有卸货港数组
     */
    extractBasicInfo(): void;
    /**
     * 数据预处理，从所有数据中提取出需要显示的数据
     */
    processData(): void;
    /**
     * 视图渲染
     */
    private redraw;
    private _fillFunction;
    private _transformFunction;
    private draw;
    static ɵfac: i0.ɵɵFactoryDeclaration<CtYardComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<CtYardComponent, "ct-yard", never, { "renderOptions": "renderOptions"; "yardposInfoList": "yardposInfoList"; "baseWidth": "baseWidth"; "baseHeight": "baseHeight"; "rotation": "rotation"; }, { "yardposClick": "yardposClick"; }, never, never>;
}
